 /*
Nahuel Jos
www.nahueljose.com.ar
*/

(function($){
	$.fn.rotarContenedores = function(opciones){
		//valores por defecto
		var defaults = {
			//opciones
			tiempo : 3000,
			auto : true
	  	};  		
		var opciones = $.extend(defaults, opciones);
		$(this).each(function(){
			var _contenedor = $(this);
			var elementos = _contenedor.find('ul > li');
			var cont_actual = elementos.first();
			
			//aplicar estilos
			elementos.css({'display':'none'});
			cont_actual.css({'display':'block'}).addClass('cont_actual');
			
			//insertar paginado
			var paginadoHtml = "<ol>"
			paginadoHtml+='<li><a href="#" class="paginado_actual">1</a></li>';
			for(i=1;i<elementos.length;i++){
				paginadoHtml+='<li><a href="#">' + parseInt(i+1) + '</a></li>';
			}
			paginadoHtml+= "</ol>"
			_contenedor.append("<div class='rotar_paginado'>"+paginadoHtml+"</div>");
			
			//obtener elementos del paginado
			var _paginados = _contenedor.find('.rotar_paginado li > a');
			_paginados.click(function(e){
				e.preventDefault();
				_saltar(parseInt($(this).text(),10)-1);
			});
			
			//asignar eventos al paginado
			
			//definir intervalo
			var _hwnd_intervalo;
			if(opciones.auto){_iniciar();}

			//funciones
			function _siguiente(cont_actual){
				cont_actual.css({'display':'none'}).removeClass('cont_actual');
				var ind_actual = elementos.index(cont_actual) + 1;
				if(ind_actual >= elementos.length){ind_actual = 0}
				$(elementos.get(ind_actual)).css({'display':'block'}).addClass('cont_actual');
				_contenedor.find('.paginado_actual').removeClass('paginado_actual');
				$(_paginados.get(ind_actual)).addClass('paginado_actual');
			}
			function _anterior(cont_actual){
				cont_actual.css({'display':'none'}).removeClass('cont_actual');
				var ind_actual = elementos.index(cont_actual) - 1;
				if(ind_actual >= elementos.length){ind_actual = 0}
				$(elementos.get(ind_actual)).css({'display':'block'}).addClass('cont_actual');
				_contenedor.find('.paginado_actual').removeClass('paginado_actual');
				$(_paginados.get(ind_actual)).addClass('paginado_actual');
			}
			function _saltar(_index){
				var cont_actual = _contenedor.find('.cont_actual');
				var saltarA = $(elementos.get(_index));
				cont_actual.css({'display':'none'}).removeClass('cont_actual');
				var ind_actual = elementos.index(saltarA);
				if(ind_actual >= elementos.length){saltarA = 0}
				$(elementos.get(ind_actual)).css({'display':'block'}).addClass('cont_actual');
				_contenedor.find('.paginado_actual').removeClass('paginado_actual');
				$(_paginados.get(ind_actual)).addClass('paginado_actual');
				if(opciones.auto){_iniciar();}
			}
			function _iniciar(){
				clearInterval(_hwnd_intervalo);
				_hwnd_intervalo= setInterval(function(){
					var cont_actual = _contenedor.find('.cont_actual');
					_siguiente(cont_actual);
				}, opciones.tiempo);
			}
		});		
		return false;
	};	
})(jQuery);